# bash completion for slackpkg tool

have slackpkg &&
_slackpkg()
{
    COMPREPLY=()
    local cur
    _get_comp_words_by_ref cur

    # based on `grep '\-.*\=.*)' /usr/sbin/slackpkg | cut -f1 -d\)`
    if [[ "$cur" == -* ]]; then
        COMPREPLY=( $( compgen -W '-delall=on -delall=off \
            -checkmd5=on -checkmd5=off \
            -checkgpg=on -checkgpg=off \
            -checksize=on -checksize=off \
            -postinst=on -postinst=off \
            -onoff=on -onoff=off \
            -download_all=on -download_all=off \
            -dialog=on -dialog=off \
            -dialog_maxargs= \
            -batch=on -batch=off \
            -only_new_dotnew=on -only_new_dotnew=off \
            -use_includes=on -use_includes=off \
            -spinning=on -spinning=off \
            -default_answer=yes -default_answer=no \
            -mirror=' -- "$cur" ) )
        return 0
    fi

    local confdir="/etc/slackpkg"
    local config="$confdir/slackpkg.conf"

    if [ ! -r "$config" ]; then
        return 0
    fi
    . "$config"

    local action words
    _get_comp_words_by_ref -n "=" words

    for (( i=1; i<${#words[@]}; i++ )); do
        if [[ "${words[i]}" != -* ]]; then
            action="${words[i]}"
            break
        fi
    done

    case $action in
        generate-template|search|file-search)
            # argument required but no completions available
            return 0
            ;;
        install-template|remove-template)
            if [ -e "$confdir/templates" ]; then
                COMPREPLY=( $( cd "$confdir/templates"; \
                    compgen -f -X "!*.template" -- "$cur" ) )
                COMPREPLY=( ${COMPREPLY[@]%.template} )
            fi
            return 0
            ;;
        remove)
            _filedir
            COMPREPLY+=( $( compgen -W 'a ap d e f k kde kdei l n t tcl x \
                xap y' -- "$cur" ) )
            COMPREPLY+=( $( cd /var/log/packages; compgen -f -- "$cur" ) )
            return 0
            ;;
        install|reinstall|upgrade|blacklist|download)
            _filedir
            COMPREPLY+=( $( compgen -W 'a ap d e f k kde kdei l n t tcl x \
                xap y' -- "$cur" ) )
            COMPREPLY+=( $( cut -f 6 -d\  ${WORKDIR}/pkglist 2> /dev/null | \
                grep "^$cur" ) )
            return 0
            ;;
        info)
            COMPREPLY+=( $( cut -f 6 -d\  ${WORKDIR}/pkglist 2> /dev/null | \
                grep "^$cur" ) )
            return 0
            ;;
        update)
            # we should complete the same as the next `list` + "gpg"
            COMPREPLY=( $( compgen -W 'gpg' -- "$cur" ) )
            ;&
        *)
            COMPREPLY+=( $( compgen -W 'install reinstall upgrade remove \
                blacklist download update install-new upgrade-all \
                clean-system new-config check-updates help generate-template \
                install-template remove-template search file-search info' -- \
                "$cur" ) )
            return 0
            ;;
    esac

} && complete -F _slackpkg slackpkg
